package org.processmining.performancespectrumintegration.algorithms.miner;

import com.google.common.collect.Multimap;
import org.apache.commons.compress.utils.Lists;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.performancespectrumintegration.util.Tuple2;

import java.util.Arrays;
import java.util.List;

public class AlignmentSemantics {

    private final List<Tuple2<Transition, TransitionExecution>> pairs;

    public AlignmentSemantics() {
        pairs = Lists.newArrayList();
    }

    public void add(Transition t, TransitionExecution e) {
        pairs.add(new Tuple2<>(t, e));
    }

    public <T extends SegmentTemplateBuilder> void applySegmentTemplateBuilders(Multimap<Transition, T> fromTriggers, Multimap<Transition, T> toTriggers) {
        for (Tuple2<Transition, TransitionExecution> pair : pairs) {
            fromTriggers.get(pair._1).forEach(st -> st.acceptFrom(pair._2));
            toTriggers.get(pair._1).forEach(st -> st.acceptTo(pair._2));
        }
    }

    @Override
    public String toString() {
        return Arrays.toString(pairs.stream().map(Object::toString).toArray());
    }
}
