package org.processmining.performancespectrumintegration.algorithms.miner;

import com.google.common.collect.ImmutableSet;
import org.processmining.performancespectrumintegration.algorithms.segments.Segment;
import org.processmining.performancespectrumintegration.models.settings.Filter;

import java.util.Set;

public class SegmentMiningParameters {

    private Filter<Integer> caseIdFilter;
    private ImmutableSet<Segment> selectedSegments;

    public SegmentMiningParameters(Filter<Integer> caseIdFilter, ImmutableSet<Segment> selectedSegments) {
        this.caseIdFilter = caseIdFilter;
        this.selectedSegments = selectedSegments;
    }

    public Set<Segment> getSelectedSegments() {
        return selectedSegments;
    }

    public void setSelectedSegments(ImmutableSet<Segment> selectedSegments) {
        this.selectedSegments = selectedSegments;
    }

    public Filter<Integer> getFilter() {
        return caseIdFilter;
    }

    public void setFilter(Filter<Integer> selectedCaseIds) {
        this.caseIdFilter = selectedCaseIds;
    }
}
