package org.processmining.performancespectrumintegration.algorithms.miner;

import java.util.LinkedList;
import java.util.List;

import static org.processmining.performancespectrumintegration.algorithms.miner.AlignmentSemanticsBuilder.ExecutionType;

public class SegmentTemplateBuilder {

    private final List<SegmentOccurrenceTemplate> occurrenceTemplates;
    private TransitionExecution lastFromEnabler = null;

    public SegmentTemplateBuilder() {
        occurrenceTemplates = new LinkedList<>();
    }

    public void acceptFrom(TransitionExecution enabler) {
        lastFromEnabler = enabler;
    }

    public void acceptTo(TransitionExecution enabler) {
        if (lastFromEnabler != null) {
            occurrenceTemplates.add(new SegmentOccurrenceTemplate(lastFromEnabler.eventIndex, enabler.eventIndex, lastFromEnabler.executionType != ExecutionType.Sync || enabler.executionType != ExecutionType.Sync));
            lastFromEnabler = null;
        }
    }

    public List<SegmentOccurrenceTemplate> getOccurrenceTemplates() {
        return occurrenceTemplates;
    }
}
