package org.processmining.performancespectrumintegration.algorithms.miner;

import org.apache.commons.collections15.ComparatorUtils;

import java.util.Comparator;

class TransitionExecution implements Comparable<TransitionExecution> {

    static TransitionExecution ARTIFICIAL_ZERO = new TransitionExecution(0, AlignmentSemanticsBuilder.ExecutionType.Artificial);

    int eventIndex;
    AlignmentSemanticsBuilder.ExecutionType executionType;

    public TransitionExecution(int eventIndex, AlignmentSemanticsBuilder.ExecutionType executionType) {
        this.eventIndex = eventIndex;
        this.executionType = executionType;
    }

    @Override
    public int compareTo(TransitionExecution o) {
        Comparator<TransitionExecution> firstComp = Comparator.comparingInt(tex -> tex.executionType.ordinal());
        Comparator<TransitionExecution> secondComp = Comparator.comparingInt(tex -> tex.eventIndex);
        Comparator comp = ComparatorUtils.chainedComparator(firstComp, secondComp);
        return comp.compare(this, o);
    }

    @Override
    public String toString() {
        return executionType + "@" + eventIndex;
    }

}
