package org.processmining.performancespectrumintegration.algorithms.petrinet;

import com.google.common.collect.Sets;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;

import java.util.Set;

public class AdjPlaces {

    private final Set<Place> preset;
    private final Set<Place> postset;

    public AdjPlaces(Set<Place> preset, Set<Place> postset) {
        this.preset = preset;
        this.postset = postset;
    }

    public Set<Place> getIntersection() {
        return Sets.intersection(preset, postset);
    }

    public Set<Place> getPreset() {
        return preset;
    }

    public Set<Place> getPostset() {
        return postset;
    }
}
