package org.processmining.performancespectrumintegration.algorithms.segments;

import com.google.common.collect.ImmutableSet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

import java.util.Objects;

public class SingleSegment implements Segment {

    private final Transition from, to;

    public SingleSegment(Transition from, Transition to) {
        assert from != null && to != null;
        this.from = from;
        this.to = to;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        SingleSegment segment = (SingleSegment) o;
        return Objects.equals(from, segment.from) &&
                Objects.equals(to, segment.to);
    }

    @Override
    public int hashCode() {
        return Objects.hash(from, to);
    }

    @Override
    public String toString() {
        return from.getLabel() + ":" + to.getLabel();
    }

    @Override
    public ImmutableSet<Transition> getFrom() {
        return ImmutableSet.of(from);
    }

    @Override
    public ImmutableSet<Transition> getTo() {
        return ImmutableSet.of(to);
    }
}
