package org.processmining.performancespectrumintegration.models;

import com.google.common.collect.Maps;
import org.processmining.performancespectrumintegration.algorithms.segments.Segment;

import java.util.Map;

public class CountsData {

    private final Map<Segment, ClassCounts> classCountsMap;

    public CountsData() {
        classCountsMap = Maps.newHashMap();
    }

    public ClassCounts getSegmentCounts(Segment segment) {
        if (!classCountsMap.containsKey(segment)) classCountsMap.put(segment, new ClassCounts());
        return classCountsMap.get(segment);
    }

    public void incStartingInSegment(Segment segment, Integer classId) {
        getSegmentCounts(segment).incStartingIn(classId);
    }

    public void incEndingInSegment(Segment segment, Integer classId) {
        getSegmentCounts(segment).incEndingIn(classId);
    }

    public void incPendingInSegment(Segment segment, Integer classId) {
        getSegmentCounts(segment).incPending(classId);
    }

    @Override
    public String toString() {
        return "CountsData{" +
                "classCountsMap=" + classCountsMap +
                '}';
    }
}
