package org.processmining.performancespectrumintegration.models;

import org.joda.time.DateTime;
import org.processmining.performancespectrumintegration.algorithms.miner.SegmentData;
import org.processmining.performancespectrumintegration.algorithms.segments.Segment;
import org.processmining.performancespectrumintegration.models.settings.CaseIdClassification;

import java.util.List;
import java.util.Set;

public interface DataControllable {

    void setSegmentData(SegmentData rawSegmentData);

    void setClassification(CaseIdClassification classification);

    void setProcessTimes(DateTime earliestTime, DateTime latestTime);

    void setSegments(Set<Segment> selectedSegments);

    void setSegmentOrder(List<Segment> segmentOrder);

    void setTimeWindowData(TimeWindowData timeWindowData);

    void setCaseNumbers(int total, int filtered);

    boolean isComplete();

}
