package org.processmining.performancespectrumintegration.models;

import com.google.common.collect.Maps;
import com.google.common.collect.Sets;
import org.joda.time.DateTime;
import org.processmining.performancespectrumintegration.algorithms.miner.SegmentData;
import org.processmining.performancespectrumintegration.algorithms.segments.Segment;
import org.processmining.performancespectrumintegration.algorithms.segments.SegmentOccurrence;
import org.processmining.performancespectrumintegration.models.settings.AggregationIntervalSettings;
import org.processmining.performancespectrumintegration.models.settings.CaseIdClassification;
import org.processmining.performancespectrumintegration.util.Tuple2;

import java.util.*;

@Deprecated
// TODO implement or not
public class EfficientTimeWindowData extends AbstractTimeWindowData {

    private final Map<Segment, SortedMap<Integer, Tuple2<Set<Integer>, Set<Integer>>>> startAndEnds;
    private final CaseIdClassification classification;

    public EfficientTimeWindowData(SegmentData segmentData, Set<Segment> selectedSegments, CaseIdClassification classification, DateTime processStart, DateTime processEnd, AggregationIntervalSettings aggregationIntervalSettings) {
        super(processStart, processEnd, aggregationIntervalSettings);
        this.classification = classification;

        startAndEnds = Maps.newHashMap();

        for (Segment segment : selectedSegments) {
            TreeMap<Integer, Tuple2<Set<Integer>, Set<Integer>>> map = Maps.newTreeMap();
            startAndEnds.put(segment, map);

            for (SegmentOccurrence so : segmentData.get(segment)) {
                Integer caseId = so.getCaseId();

                int s = bin(so.getStartTime());
                int e = bin(so.getEndTime());

                check(map, s)._1.add(caseId);
                check(map, e)._2.add(caseId);

            }
        }
    }

    private Tuple2<Set<Integer>, Set<Integer>> check(TreeMap<Integer, Tuple2<Set<Integer>, Set<Integer>>> map, Integer bin) {
        if (!map.containsKey(bin))
            map.put(bin, new Tuple2<>(Sets.newHashSet(), Sets.newHashSet()));
        return map.get(bin);
    }

    @Override
    public Iterable<BinClassCounts> getCounts(Segment segment) {
        return null;
    }

    @Override
    public Iterable<BinClassCounts> getSubsetCounts(Segment segment, DateTime from, DateTime to) {
        return null;
    }

    @Override
    public Iterable<BinClassCounts> getSubsetCounts(Segment segment, int from, int to) {
        return null;
    }

    @Override
    public ClassCounts.Counts max(Segment segment) {
        return null;
    }

    @Override
    public boolean containsAll(Collection<Segment> selectedSegments) {
        return startAndEnds.keySet().containsAll(selectedSegments);
    }


    private class MyIterable implements Iterable<BinClassCounts> {

        private final SortedMap<Integer, Tuple2<Set<Integer>, Set<Integer>>> map;

        public MyIterable(SortedMap<Integer, Tuple2<Set<Integer>, Set<Integer>>> map) {
            this.map = map;
        }

        @Override
        public Iterator<BinClassCounts> iterator() {
            return new MyIterator();
        }


        private class MyIterator implements Iterator<BinClassCounts> {
            private final Map<Integer, Set<Integer>> openCasesPerClass;

            public MyIterator() {
                openCasesPerClass = Maps.newTreeMap();
                for (Integer aClass : classification.getClasses()) {
                    openCasesPerClass.put(aClass, Sets.newHashSet());
                }

                Iterator<Map.Entry<Integer, Tuple2<Set<Integer>, Set<Integer>>>> iterator = map.entrySet().iterator();
                Map.Entry<Integer, Tuple2<Set<Integer>, Set<Integer>>> next = iterator.next();

            }


            @Override
            public boolean hasNext() {
                return false;
            }

            @Override
            public BinClassCounts next() {
                return null;
            }
        }
    }


}
