package org.processmining.performancespectrumintegration.models;

import org.deckfour.xes.model.XLog;
import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.performancespectrumintegration.parameters.PSMParameters;
import org.processmining.performancespectrumintegration.visualization.controller.InteractivePSMController;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;

import javax.swing.*;

public class InteractivePSM {

    private final XLog log;
    private final AcceptingPetriNet net;
    private final PNRepResult pnRepResult;
    private PSMParameters psmParameters;

    public InteractivePSM(XLog log, AcceptingPetriNet acceptingPetriNet, PNRepResult pnRepResult, PSMParameters psmParameters) {
        this.log = log;
        this.net = acceptingPetriNet;
        this.pnRepResult = pnRepResult;
        this.psmParameters = psmParameters;
    }

    public XLog getLog() {
        return log;
    }

    public AcceptingPetriNet getAcceptingNet() {
        return net;
    }

    public PNRepResult getPnRepResult() {
        return pnRepResult;
    }

    public JComponent getComponentForContext(final UIPluginContext context) {
        return new InteractivePSMController(context, this).getComponent();
    }

    public PSMParameters getPsmParameters() {
        return psmParameters;
    }
}
