package org.processmining.performancespectrumintegration.models.settings;

import java.io.Serializable;
import java.util.Objects;

public class ClassificationSettings implements Serializable {

    public static final ClassificationSettings NONE = new ClassificationSettings(ClassificationType.None) {
        @Override
        public String toString() {
            return "None";
        }
    };

    private ClassificationType type;

    public ClassificationSettings() {
    }

    public ClassificationSettings(ClassificationType type) {
        this.type = type;
    }

    public ClassificationType getType() {
        return type;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ClassificationSettings that = (ClassificationSettings) o;
        return type == that.type;
    }

    @Override
    public int hashCode() {
        return Objects.hash(type);
    }

    @Override
    public String toString() {
        return "ClassificationSettings{" +
                "type=" + type +
                '}';
    }
}
