package org.processmining.performancespectrumintegration.models.settings;

import java.util.Objects;

public class DurationClassesClassificationSettings extends ClassificationSettings {

    private final int classes;

    public DurationClassesClassificationSettings(int classes) {
        super(ClassificationType.CaseDurationClasses);
        this.classes = classes;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        DurationClassesClassificationSettings that = (DurationClassesClassificationSettings) o;
        return classes == that.classes;
    }

    @Override
    public int hashCode() {
        return Objects.hash(super.hashCode(), classes);
    }

    public int getClasses() {
        return classes;
    }

    @Override
    public String toString() {
        return classes + " classes";
    }
}
