package org.processmining.performancespectrumintegration.models.settings;

import com.google.common.base.Objects;
import org.joda.time.Duration;
import org.processmining.performancespectrumintegration.util.ToStrings;

public class DurationThresholdClassificationSettings extends ClassificationSettings {

    private final Duration thresholdDuration;

    public DurationThresholdClassificationSettings(Duration thresholdDuration) {
        super(ClassificationType.CaseDurationThreshold);
        this.thresholdDuration = thresholdDuration;
    }

    public Duration getThresholdDuration() {
        return thresholdDuration;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        DurationThresholdClassificationSettings that = (DurationThresholdClassificationSettings) o;
        return Objects.equal(thresholdDuration, that.thresholdDuration);
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(super.hashCode(), thresholdDuration);
    }

    @Override
    public String toString() {
        return ToStrings.print(thresholdDuration);
    }
}
