package org.processmining.performancespectrumintegration.models.settings;

import org.joda.time.Duration;
import org.processmining.performancespectrumintegration.util.ToStrings;

import java.util.Objects;

public class DurationThresholdFilterSettings extends FilterSettings {

    private final Duration thresholdDuration;
    private final boolean inverted;

    public DurationThresholdFilterSettings(Duration thresholdDuration, boolean inverted) {
        super(FilterType.CaseDurationThreshold);
        this.thresholdDuration = thresholdDuration;
        this.inverted = inverted;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DurationThresholdFilterSettings that = (DurationThresholdFilterSettings) o;
        return inverted == that.inverted &&
                Objects.equals(thresholdDuration, that.thresholdDuration);
    }

    @Override
    public int hashCode() {
        return Objects.hash(thresholdDuration, inverted);
    }

    @Override
    public String toString() {
        return (inverted ? ">= " : "<= ") + ToStrings.print(thresholdDuration);
    }

    public Duration getThresholdDuration() {
        return thresholdDuration;
    }

    public boolean isInverted() {
        return inverted;
    }
}
