package org.processmining.performancespectrumintegration.models.settings;

import java.io.Serializable;
import java.util.Objects;

public class FilterSettings implements Serializable {

    public static final FilterSettings NONE = new FilterSettings(FilterType.None) {
        @Override
        public String toString() {
            return "None";
        }
    };

    private FilterType type;

    private FilterSettings() {
    }

    public FilterSettings(FilterType type) {
        this.type = type;
    }

    public FilterType getType() {
        return type;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        FilterSettings that = (FilterSettings) o;
        return type == that.type;
    }

    @Override
    public int hashCode() {
        return Objects.hash(type);
    }

    @Override
    public String toString() {
        return "FilterSettings{" +
                "type=" + type +
                '}';
    }
}
