package org.processmining.performancespectrumintegration.models.settings;

import java.util.Objects;

public class PercentileClassificationSettings extends ClassificationSettings {

    private final double topPercentage;

    public PercentileClassificationSettings(ClassificationType type, double topPercentage) {
        super(type);
        this.topPercentage = topPercentage;
    }

    public double getTopPercentage() {
        return topPercentage;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        PercentileClassificationSettings that = (PercentileClassificationSettings) o;
        return Double.compare(that.topPercentage, topPercentage) == 0;
    }

    @Override
    public int hashCode() {
        return Objects.hash(super.hashCode(), topPercentage);
    }

    @Override
    public String toString() {
        return "split at top " + String.format("%.2f%%", 100 * topPercentage);
    }

}
