package org.processmining.performancespectrumintegration.models.settings;

import org.processmining.performancespectrumintegration.algorithms.segments.Segment;

import java.util.List;
import java.util.Objects;

public class SegmentOrderSettings {

    public static SegmentOrderSettings HEURISTIC = new SegmentOrderSettings(null);

    private final List<Segment> predefinedOrder;

    public SegmentOrderSettings(List<Segment> predefinedOrder) {
        this.predefinedOrder = predefinedOrder;
    }

    public boolean usePredefined() {
        return predefinedOrder != null;
    }

    public List<Segment> getPredefinedOrder() {
        return predefinedOrder;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        SegmentOrderSettings that = (SegmentOrderSettings) o;
        return Objects.equals(predefinedOrder, that.predefinedOrder);
    }

    @Override
    public int hashCode() {
        return Objects.hash(predefinedOrder);
    }

    @Override
    public String toString() {
        return predefinedOrder != null ? predefinedOrder.toString() : "use heuristic";
    }

}
