package org.processmining.performancespectrumintegration.models.settings;

import java.util.Objects;
import java.util.Set;

public class SetBasedFilter implements CaseIdFilter {

    private final boolean inverted;
    private final Set<Integer> allowed;

    public SetBasedFilter(Set<Integer> allowed) {
        this(allowed, false);
    }

    public SetBasedFilter(Set<Integer> allowed, boolean inverted) {
        this.allowed = allowed;
        this.inverted = inverted;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        SetBasedFilter that = (SetBasedFilter) o;
        return Objects.equals(allowed, that.allowed);
    }

    @Override
    public int hashCode() {
        return Objects.hash(allowed);
    }

    @Override
    public boolean isIncluded(Integer i) {
        return inverted ^ allowed.contains(i);
    }

}
