package org.processmining.performancespectrumintegration.mypsm;

import org.processmining.performancespectrumintegration.models.settings.DataSettings;
import org.processmining.performancespectrumintegration.mypsm.update.PSMUpdateListener;
import org.processmining.performancespectrumintegration.mypsm.update.PSMUpdateManager;

import javax.swing.*;
import java.awt.*;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

public class ClassificationLegendFrame extends JFrame implements PSMUpdateListener {

    private final PSMUpdateManager psmUpdateManager;

    public ClassificationLegendFrame(String title, PSMUpdateManager psmUpdateManager, JButton boundButton) throws HeadlessException {
        this.psmUpdateManager = psmUpdateManager;

        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        setTitle(title);

        addWindowListener(new WindowListener() {
            @Override
            public void windowOpened(WindowEvent e) {

            }

            @Override
            public void windowClosing(WindowEvent e) {
                psmUpdateManager.removeListener(ClassificationLegendFrame.this);
                boundButton.setEnabled(true);
                boundButton.repaint();
            }

            @Override
            public void windowClosed(WindowEvent e) {

            }

            @Override
            public void windowIconified(WindowEvent e) {

            }

            @Override
            public void windowDeiconified(WindowEvent e) {

            }

            @Override
            public void windowActivated(WindowEvent e) {

            }

            @Override
            public void windowDeactivated(WindowEvent e) {

            }
        });

        psmUpdateManager.addListener(this);

        JPanel jp = new JPanel();
        setContentPane(jp);

        remake();
    }

    private void remake() {
        getContentPane().removeAll();
        ClassificationLegendPanel classificationLegendPanel = new ClassificationLegendPanel(psmUpdateManager);
        getContentPane().add(classificationLegendPanel);
        getContentPane().revalidate();
        getContentPane().repaint();
        Dimension preferredSize = getContentPane().getPreferredSize();
        if (preferredSize.width < 400 && preferredSize.height < 300)
            setPreferredSize(new Dimension(400, 200));
        //else
        //    setSize(preferredSize.width + 10, preferredSize.height + 40);

        pack();
    }

    @Override
    public void onDataSourceChanged(DataSettings deltaSettings) {
        SwingUtilities.invokeLater(() -> {
            if (deltaSettings.getClassificationSettings() != null || deltaSettings.getFilterSettings() != null) {
                remake();
            }
        });
    }

}
