package org.processmining.performancespectrumintegration.mypsm;

import org.processmining.performancespectrumintegration.mypsm.update.PSMUpdateManager;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.*;

public class PSMPanel extends JPanel {

    public static final int MIN_WIDTH = 1000;

    public PSMPanel(PSMUpdateManager psmUpdateManager) {
        setPreferredSize(new Dimension(1055, 1080));
        setMinimumSize(new Dimension(MIN_WIDTH, 400));
        setLayout(new GridBagLayout());

        SegmentsListPanel segmentsListPanel = new SegmentsListPanel(psmUpdateManager);

        PSMTimeScalePanel psmTimeScale = new PSMTimeScalePanel(psmUpdateManager);

        PSMControlBar psmControlBar = new PSMControlBar(psmUpdateManager, segmentsListPanel);

        GridBagConstraints c = new GridBagConstraints();
        c.gridx = 0;
        c.weightx = 1;

        c.fill = GridBagConstraints.BOTH;
        c.gridy = 0;
        c.anchor = GridBagConstraints.NORTH;
        c.weighty = 1;
        add(segmentsListPanel, c);
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridy = 1;
        c.weighty = 0;
        c.anchor = GridBagConstraints.SOUTH;
        add(psmTimeScale, c);
        c.gridy = 2;
        TitledBorder border = new TitledBorder("Visualization Settings");
        psmControlBar.setBorder(border);
        add(psmControlBar, c);

    }


}
