package org.processmining.performancespectrumintegration.plugins;


import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.performancespectrumintegration.parameters.ImportExportPSMParameters;
import org.processmining.performancespectrumintegration.parameters.PSMParameters;

import java.io.File;
import java.io.IOException;

@Plugin(name = "Serialize PSMParameters", level = PluginLevel.NightlyBuild, parameterLabels = {"PSMParameters", "File"}, returnLabels = {}, returnTypes = {}, userAccessible = true)
@UIExportPlugin(description = "serialized object", extension = "bin")
public class ExportPlugin {

    @UITopiaVariant(affiliation = "PADS RWTH", author = "Daniel Tacke genannt Unterberg", email = "daniel.tacke.unterberg@rwth-aachen.de")
    @PluginVariant(requiredParameterLabels = {0, 1}, variantLabel = "Serialize PSMParameters")
    public void export(UIPluginContext context, PSMParameters psmParameters, File file) throws IOException {
        ImportExportPSMParameters.write(file, psmParameters);
    }


}
