package org.processmining.performancespectrumintegration.plugins;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.performancespectrumintegration.parameters.ImportExportPSMParameters;
import org.processmining.performancespectrumintegration.parameters.PSMParameters;

import java.io.InputStream;

@Plugin(name = "Deserialize PSMParameters", level = PluginLevel.NightlyBuild, parameterLabels = {"Filename"}, returnLabels = {"PSMParameters"}, returnTypes = {PSMParameters.class})
@UIImportPlugin(description = "PSMParameters", extensions = {"bin"})
public class ImportPlugin extends AbstractImportPlugin {

    /*
    public FileFilter getFileFilter() {
        return new FileNameExtensionFilter("PSM Parameters", "bin");
    }
     */

    public Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes) throws Exception {
        context.getFutureResult(0).setLabel(filename);
        return ImportExportPSMParameters.read(input);
    }
}
