package org.processmining.performancespectrumintegration.visualization;

import java.awt.*;

public enum PlaceSelectionState {
    Off(Color.darkGray), Individual(Color.green), Aggregate(Color.blue);

    private final Color color;

    PlaceSelectionState(Color color) {
        this.color = color;
    }

    public static PlaceSelectionState getDefault() {
        return Off;
    }

    public PlaceSelectionState next() {
        PlaceSelectionState[] values = values();
        return values[(ordinal() + 1) % values.length];
    }

    public Color getColor() {
        return color;
    }
}
