package org.processmining.performancespectrumintegration.visualization.controller;

import java.util.ArrayList;
import java.util.Collection;

public class ExecutionStatusConnection {

    private ExecutionStatus status;
    private Collection<ExecutionStatusListener> listeners;

    public ExecutionStatusConnection() {
        status = ExecutionStatus.Done;
        listeners = new ArrayList<>(1);
    }

    public void register(ExecutionStatusListener executionStatusListener) {
        listeners.add(executionStatusListener);
    }

    public ExecutionStatus getStatus() {
        return status;
    }

    public void setStatus(ExecutionStatus status) {
        this.status = status;
        listeners.forEach(l -> l.update(status));
    }

    public enum ExecutionStatus {
        Dirty, Running, Done
    }

}
