package org.processmining.performancespectrumintegration.visualization.controller;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.performancespectrumintegration.models.InteractivePSM;
import org.processmining.performancespectrumintegration.visualization.SettingsPanel;
import org.processmining.performancespectrumintegration.visualization.TopPanel;

import javax.swing.*;
import javax.swing.border.TitledBorder;

public class InteractivePSMController {

    private final JPanel content;

    public InteractivePSMController(UIPluginContext context, InteractivePSM interactivePSM) {
        content = new JPanel();

        SwingUtilities.invokeLater(() -> {
            TopPanel topPanel = new TopPanel(context, interactivePSM);
            SettingsPanel settingsPanel = new SettingsPanel(context, topPanel, interactivePSM);

            if (interactivePSM.getPsmParameters() != null)
                settingsPanel.clickApplySettings();
            else {
                // TODO arbitrary
                int placeCount = interactivePSM.getAcceptingNet().getNet().getPlaces().size();
                int casesCount = interactivePSM.getLog().size();

                if (casesCount < 10000 && placeCount < 30) settingsPanel.setToInstantMode();
            }

            content.add(topPanel);

            TitledBorder titledBorder = new TitledBorder("Data Settings");
            settingsPanel.setBorder(titledBorder);
            content.add(settingsPanel);

            content.setLayout(new BoxLayout(content, BoxLayout.Y_AXIS));

        });

    }


    public JComponent getComponent() {
        return content;
    }

}
