package org.processmining.performancespectrumintegration.visualization.help;

import com.fluxicon.slickerbox.components.SlickerButton;
import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;
import org.processmining.framework.util.ui.scalableview.ScalableComponent;
import org.processmining.framework.util.ui.scalableview.ScalableViewPanel;
import org.processmining.framework.util.ui.scalableview.interaction.ViewInteractionPanel;

import javax.swing.*;

public class ButtonViewInteractionPanel extends JPanel implements ViewInteractionPanel {

    private final Runnable buttonAction;
    private final String name;
    private final String buttonText;
    private final SlickerButton button;

    public ButtonViewInteractionPanel(Runnable runnable, String name, String buttonText) {
        this.buttonText = buttonText;
        this.buttonAction = runnable;
        this.name = name;
        double size[][] = {{10, TableLayoutConstants.FILL, 10}, {10, TableLayoutConstants.FILL, 10}};
        setLayout(new TableLayout(size));
        button = new SlickerButton(buttonText);
        button.addActionListener(e -> runnable.run());
        this.add(button, "1, 1");
    }


    @Override
    public String getPanelName() {
        return name;
    }

    @Override
    public JComponent getComponent() {
        return this;
    }

    @Override
    public void setScalableComponent(ScalableComponent scalableComponent) {

    }

    @Override
    public void setParent(ScalableViewPanel scalableViewPanel) {

    }

    @Override
    public double getHeightInView() {
        return 50;
    }

    @Override
    public double getWidthInView() {
        return 7 * buttonText.length();
    }

    @Override
    public void willChangeVisibility(boolean b) {

    }

    @Override
    public void updated() {

    }
}
