package org.processmining.performancespectrumintegration.visualization.help;

import com.fluxicon.slickerbox.factory.SlickerFactory;
import org.processmining.performancespectrumintegration.util.Utils;

import javax.swing.*;
import java.awt.*;

public class GraphLegendPanel extends JPanel {

    private static final Icon legendIcon = Utils.loadImageIcon("legend.png");
    private static final Icon measureIcon = Utils.loadImageIcon("measure.png");
    private static final Icon measureWithRemoveIcon = Utils.loadImageIcon("measureWithRemove.png");
    private final JPanel cards;

    public GraphLegendPanel() {
        CardLayout cardLayout = new CardLayout();
        cards = new JPanel(cardLayout);

        addCard(legendIcon, "Legend");
        addCard(measureIcon, "Measure");
        addCard(measureWithRemoveIcon, "Measure With Remove");

        JPanel controlPanel = new JPanel();
        JButton previousButton = SlickerFactory.instance().createButton("previous");
        previousButton.addActionListener(e -> cardLayout.previous(cards));
        controlPanel.add(previousButton);
        JButton nextButton = SlickerFactory.instance().createButton("next");
        nextButton.addActionListener(e -> cardLayout.next(cards));
        controlPanel.add(nextButton);

        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
        add(cards);
        add(controlPanel);

        cardLayout.show(cards, "Legend");
    }

    private void addCard(Icon icon, String name) {
        JPanel jp = new JPanel(new GridBagLayout());
        jp.add(new JLabel(icon));
        jp.setPreferredSize(new Dimension(icon.getIconWidth(), icon.getIconHeight()));
        cards.add(jp, name);
    }

}
