package org.processmining.performancespectrumintegration.visualization.help;

import javax.swing.*;

public class HelpPanels {

    private static void makeWindow(JComponent jComponent, String title) {
        SwingUtilities.invokeLater(() -> {
            JFrame jf = new JFrame(title);
            jf.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
            jf.getContentPane().add(jComponent);
            jf.pack();
            jf.setVisible(true);
        });
    }

    public static class ControlsHelpButtonPanel extends ButtonViewInteractionPanel {
        public ControlsHelpButtonPanel() {
            super(() -> {
                makeWindow(new ControlsHelpPanel(), "Controls Help");
            }, "Controls Help", "open controls help");
        }
    }

    public static class GraphLegendButtonPanel extends ButtonViewInteractionPanel {
        public GraphLegendButtonPanel() {
            super(() -> {
                makeWindow(new GraphLegendPanel(), "Graph Help");
            }, "Graph Help", "open graph legend");
        }
    }

}
